#ifndef GARBAGEFLAVORIMAGE_H
#define GARBAGEFLAVORIMAGE_H

#include <GL/glut.h>

#include "Garbage.h"

/* static */ class GarbageFlavorImage {
public:
  static void initialize (   );

  static bool personalGarbageFlavorImageExists (   );
  static GLubyte *loadPersonalGarbageFlavorImage (   );
  static void handleNetworkGarbageFlavorImage ( GLubyte *texture );
  static void buildGarbageTextureFileName ( char file_name[256], int n );

  static void requestGarbageFlavorImage ( Garbage &garbage );

  static inline void notifyGarbageDestruction ( Garbage &garbage )
  {
    if (garbage.id == associated_garbage_id)
      associated_garbage_id = -1;
  }

  static int current_texture;
  static int associated_garbage_id;
  static int x, y;
  static bool network_texture;
};

#endif
